/* $Id: datoPrint.c,v 2.4 1995/04/01 10:59:25 lupus Exp $ */

#include <time.h>
#include <stdio.h>
#include <string.h>

#include "datoPrint.h"
#include "country.h"

static char datoBuf[80];

static int dim[] = { 0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};

long incr(long dat) {
   int y,m,d;
   char skud;

   y=dat/10000;
   m=(dat-10000*y)/100; 
   d=dat-10000*y-100*m; 

   dim[2]=28;
   skud = y%4==0 && y%100!=0 || y%400==0;
   if ( skud ) dim[2]=29;		/* i tilflde af skudr */

   if( m>12 )
     m=12;
   if( m<1 )
     m=1;

   d++;
   if( d>dim[m] ) {
     d=1;
     m++;
     if( m>12 ) {
       m=1;
       y++;
     }
   }
   return y*10000+m*100+d;
}

long incrMon(long dat) {
   int y,m,d;
   char skud;

   y=dat/10000;
   m=(dat-10000*y)/100; 
   d=dat-10000*y-100*m; 

   dim[2]=28;
   skud = y%4==0 && y%100!=0 || y%400==0;
   if ( skud ) dim[2]=29;		/* i tilflde af skudr */

   if( m>12 )
     m=12;
   if( m<1 )
     m=1;

   m++;
   if( m>12 ) {
     m=1;
     y++;
   }
   return y*10000+m*100+d;
}

long decr(long dat) {
   int y,m,d;
   char skud;

   y=dat/10000;
   m=(dat-10000*y)/100; 
   d=dat-10000*y-100*m; 

   dim[2]=28;
   skud = y%4==0 && y%100!=0 || y%400==0;
   if ( skud ) dim[2]=29;		/* i tilflde af skudr */

   if( m>12 )
     m=12;
   if( m<1 )
     m=1;

   d--;
   if( d<1 ) {
     m--;
     if( m<1 ) {
       m=12;
       y--;
     }
     d=dim[m];
   }
   return y*10000+m*100+d;
}

long decrMon(long dat) {
   int y,m,d;
   char skud;

   y=dat/10000;
   m=(dat-10000*y)/100; 
   d=dat-10000*y-100*m; 

   if( m>12 )
     m=12;
   if( m<1 )
     m=1;
   
   m--;
   if( m<1 ) {
     m=12;
     y--;
   }
   return y*10000+m*100+d;
}

void datoSkriv(char *s, long dat) {
  sprintf(s, "%d", dat);
}

long datoIdag(void) {
  time_t tid;
  struct tm *tidStruct;

  time(&tid);
  tidStruct=localtime(&tid);
  return (long)(tidStruct->tm_year*10000+(tidStruct->tm_mon+1)*100+tidStruct->tm_mday);
}

char *datoPrint(void) {
  time_t tid;
  struct tm *tidStruct;

  time(&tid);
  tidStruct=localtime(&tid);
  sprintf(datoBuf, "Ver 4.5  %s: %02d%02d%02d", DATE1, tidStruct->tm_year,
	  tidStruct->tm_mon+1, 
	  tidStruct->tm_mday );
  return datoBuf;
}

/* Versioner: 
                  Prae-versionsnummer: Foerste xfinans er udviklet
		  i juleferien 1993, dele af koden er overtaget direkte fra
		  DOS-version 4.4 (bl.a. datastrukturer, fil-I/O, 
		  renteberegning mv.)
   931231   1.1   Original version. Opret og Slet konto er indtil videre kun
                  implementeret som dummy-knapper.
   940102   1.2   Mindre forbedringer, ny post kan gives start-vaerdi, danske
                  bogstaver kan "indtastes".
   940104   1.3   Slet alt-knap paa postering-popup. 
                  Overfoer kan gives startvaerdi.
                  Dags-dato knap tilfoejet postering-popup
   940105   1.4   Udskriv check-funktion implementeret
   940115   1.5   Dags dato og versionsnummer skrives i hjoernet, 
                  fancy icon lavet.
                  Opret og Slet konto er nu implementeret.
   940117   1.6   Alle poster/skaermfuld toggle-knap tilfoejet
   940125   1.6 revision 1 "Resources" flyttet fra application-def. file
		  til koden.
   940130   1.7   Forbedring af CLIST-implementationen (bruger nu memcpy() 
                  og strcpy() -> betydelig mere effektivt)
		  Grum fejl rettet: Det var den forkerte postering, der blev
		  slettet af "ret post" i bestemte tilfaelde
   940201   1.8   Udskriv check sker nu til fil i stedet for til /dev/lp
   940303   2.0   Nyt 3D-look gennem ny version af Xaw-biblioteket (Xaw3d)
   940404   2.1   Nye kontoformer: - Pantebrev, beregning af amortisations-
                                     ydelse.
				   - Aktier, beregning af kursvaerdi og
                                     kursgevinst
		  Disse konti skelnes fra alm. konti ved extensionen 
		  paa deres filnavn (.pan hhv .akt), som dermed har 
		  faaet en semantisk betydning.
   940506   2.2   Plus/Minus knapper til dato-indtastning
   940522   2.4   Hoved-vinduet forbedret med en "pane"-tingest
   940603   2.5   Antal poster der vises tilpasses nu stoerrelsen af vinduet
   940607   2.6   Nu to versioner: Een til Postscript-udskrift, een til text
                  Text-versionen skriver til printeren via "lpr -Plp xf.txt",
		  postscript gaar stadig til filen xf.ps.
		  De to versioner bygges ved at saette POSTSCRIPT i post.c
		  til hhv 0 eller 1
   940608   2.6 revision 1   Postscript-versionen skriver nu ogsaa ud, via
                             lpr -Plw xf.ps
   940612   2.7   Check-udskrivning sker nu til 'checkConfig'-fil, der via
                  Perl-scriptet 'check' kan skrives ud paa printeren
		  ('check | lpr -Praw')
   940614   2.7 revision 1   Check-script forbedret, saaledes at vi er
                             uafh. af "kartotek"-filen. At udskrive:
			     'check cconfig | lpr -Praw'.
   940615   2.8   Posterings-soegning implementeret			    
   940720   2.9   Month+/Month- knapper til dato-indtastning.
   940728   2.9 revision 1  Valgte Posteringer laegges nu i X-cut buffer 0,
                  saa de umiddelbart kan klikkes over i andre vinuder.
		  F.eks. til mit Perl-script, der kan regne posteringer sammen.
   940801   3.0   Info-popupvindue tilfjet, manualen skrevet.
   940819   3.0 revision 1  Danske bogstaver er nu helt "normale" ved 
                  indtastning, pga. tilfoejelse til app.-defaults-filen.
		  Ligeledes virker nu <delete>, <home>, <end>, <page-up>
		  og <page-down>-tasterne.
   940821   3.0 revision 2  Xfinans-logoet indsat paa udskrifter i 
                  ps-versionen
   940822   3.1   Printer-valg+PS/ascii-konfiguration-popup-vindue 
                  Forbedret PostScript-udskriftlayout.
   940825   3.1 revision 1  Paa udskrifter skrives nu i foerste linie
                  hvad kontoens saldo var foer udskriftens foerste 
		  postering.
   940903   3.2   "accelerators" tilfoejet: tasten 'q' virker nu som "hot-key"
                  for afslutning af programmet, naar tasten aktiveres et sted
		  i hovedvinduet. 
   941105   3.3   Saldo-oversigt tilfoejet
   941106   3.3 revision1  Saldo-oversigten opdateres nu ogsaa korrekt
                  i forbindelse med overfoersler.
   950101   3.4   Fejlmeddelelser vises nu i et popup-vindue.
   950103   3.5   Plot via Gnuplot
   950104   3.6   Redesign af det gamle soege-vindue (som nu er funktions-
                  vindue. Redesign af plot-kontrol-vinduet. Konti tilfoejes
		  nu kun til saldo-oversigten via "vaelg"-knappen.
		  Hotkeys til saldo-visning (s) og plot (p).
		  Der kan nu soeges paa regulaere udtryk, ikke blot ord.
   950130   3.7   Tilbage til almindelig s{\o}gning.
                  Internationalisering
		  Diverse optimeringer, oprydninger, subtile fejl rettet
   950228   4.0   Der sker nu ikke ulykker, naar der tastes <return>
                  i et input-felt. Nu ignoreres <return>; det ville vaere 
		  smart, hvis fokus kunne "warpes" til det naeste felt.
		  "Rigtig" menu tilfoejet; anvendes til at vaelge udskrift,
		  soegning, renteberegning, plot, og saldo-liste.
   950301   4.1   Soege-vinduet opdateres nu loebende, naar kontoen 
                  editeres. Dog: Naar soege- eller saldo-vinduet har
                  vaeret lukket, og derefter aabnes igen, er det ikke 
                  noedvendigvis konsistent med kontoen, foer kontoen 
		  genaabnes eller der soeges paany.
   950302   4.1 revision 1  'Alle poster' flyttet ind paa menuen - med 
                  "flueben" til at indikere aktuel tilstand.
   950304   4.1 revision 2  Forbedret robusthed - for smaa eller store
                  data skulle nu haandteres korrekt.
   950305   4.1 revision 3  Stadig bedre robusthed - alle 'malloc' kald
                  checkes nu for succes.
   950311   4.2   Menu til printer-type-valg.
   950312   4.2 revision 1  Flueben saettes nu fra starten, paa printer-
                  type-valg-menuen.   
   950316   4.3   Fejl rettet; strncpy kaldes nu via zeroAddStrncpy
   950317   4.3 revision 1  Tilrettet app-defaults file
   950318   4.3 revision 2  Forsoeger nu at leve op til PostScript DSC
   950319   4.3 revision 3  Sidenumre paa PS-prints, stoerre bundmargin.
                  Advarsel + korrekt opfoersel gives ved indtastning 
		  af >= max posteringer
   950325   4.4   Kontonummer paa udskrifter. Rename af div. funktioner i
                  clist.
   950327   4.4 revision 1  "committed" transaktioner indfoert.
   950328   4.4 revision 2  Nu fjernes temporaere plot-filer automatisk.
                            Forbedret main-menu struktur.
   950329   RCS v 2.1
   950331   4.5  Hypertext-help
   950401   4.5 revision 1  Context-sensitive help

*/
