/* $Id: gregor.c,v 2.1 1995/03/30 16:13:17 lupus Exp lupus $ */

/* int rentedage(long,long) */

/* returnerer antallet af rentedage mellem 1. og 2. argument */
/* beregningen foretages korrekt efter den gregorianske kalender */
/* Datoformat: yymmdd */

#include <stdlib.h>

/* rente_gregoriansk() */
/* Denne funktion er en hjlpefunktion til rentedage() */
/* Forskellen er, at rente_gregoriansk() skal have to datoer, der ligger */
/* i samme kalenderr.	*/

static int rente_gregoriansk(dat1,dat2)
long int dat1,dat2;
{
   long y1,y2,m1,m2,d1,d2;
   int dage;
   static int dim[] = { 0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
   char t, skud;

   y1=dat1/10000; y2=dat2/10000;

   if(y1!=y2)
      {
      /* printf("Det skal vre samme r i de to argumenter til rente_gregoriansk()!\n"); */
      return 0;
      }

   m1=(dat1-10000*y1)/100; m2=(dat2-10000*y2)/100;
   d1=dat1-10000*y1-100*m1; d2=dat2-10000*y2-100*m2;

   skud = y1%4==0 && y1%100!=0 || y1%400==0;
   if ( skud ) dim[2]=29;		/* i tilflde af skudr */

   if (m1>m2)		/* fejl i data */
      return( -1 );     /* returner -1 */
   if (m1==m2)
      dage=d2-d1;
   else
      if (m1==m2-1)
	 dage=dim[m1]-d1+d2;
      else
	 {
	 dage=dim[m1]-d1;
	 m1++;
	 for( t=m1; t<m2; t++)
	    dage+=dim[t];
	 dage+=d2;
	 }

   return( dage );
}

int rentedage(dag1,dag2)
long dag1, dag2;
{
   int y1,y2,dage;
   long slutdato, startdato;
   y1=dag1/10000; y2=dag2/10000;
   if (y1>y2)		/* fejl i data */
      return( -1 );	/* returnr -1 */
   if (y1==y2)
      return( rente_gregoriansk(dag1,dag2) );
   if (y1==y2-1)
      {
      slutdato=(long) y1*10000+1231;	/* Del op i to: resterende del af */
					/* frste r og frste del af 	  */
					/* sidste r */
      dage=rente_gregoriansk(dag1,slutdato);
      startdato=(long) y2*10000+101;
      dage+=rente_gregoriansk(startdato,dag2);
      return( ++dage );
      }
   else
      {
      slutdato=(long) y1*10000+1231;
      dage=rente_gregoriansk(dag1,slutdato);
      y1++;
      while( y1<y2 )
	 {
	 dage += (y1%4==0 && y1%100!=0 || y1%400==0) ? 366:365;
	 y1++;
	 }
      startdato=(long) y2*10000+101;
      dage+=rente_gregoriansk(startdato,dag2);
      return(++dage);
      }
}
