/* $Id: opretKonto.c,v 2.2 1995/04/01 10:59:25 lupus Exp lupus $ */

#include <time.h>
#include <string.h>

#include "opretKontop.h"
#include "opretKonto.h"
#include "konto.h"
#include "xfinans.h"
#include "xfError.h"
#include "country.h"
#include "str.h"

void createOpretKontoWidgets(void) {
  static int done=0;
  
  if(done)
    return;
  done=1;

  opretKonShell = XtVaCreatePopupShell (
					"opretKonShell",
					transientShellWidgetClass,
					topLevel,
					XtNtitle, CREATE_ACCOUNT_TITLE,
					NULL );
  
  opretKonForm = XtVaCreateManagedWidget(
				   "opretKonForm",
				   formWidgetClass,
				   opretKonShell,
				   NULL);
  
  opretKonFilOut = XtVaCreateManagedWidget(
					   "opretKonFilOut",
					   labelWidgetClass,
					   opretKonForm,
					   XtNlabel, FILE_NAME,
					   NULL);
  
  opretKonFilIn = XtVaCreateManagedWidget(
					  "opretKonFilIn",
					  asciiTextWidgetClass,
					  opretKonForm,
					  XtNeditType, XawtextEdit,
					  XtNwidth, 20*6+3,
					  XtNfromHoriz, opretKonFilOut,
					  NULL);
  
  opretKonNavnOut = XtVaCreateManagedWidget(
					    "opretKonNavnOut",
					    labelWidgetClass,
					    opretKonForm,
					    XtNlabel, NAME,
					    XtNfromVert, opretKonFilOut,
					    NULL);

  opretKonNavnIn = XtVaCreateManagedWidget(
					   "opretKonNavnIn",
					   asciiTextWidgetClass,
					   opretKonForm,
					   XtNeditType, XawtextEdit,
					   XtNwidth, KONTO_NAME_LENGTH*6+3,
					   XtNfromHoriz, opretKonNavnOut,
					   XtNfromVert, opretKonFilOut,
					   NULL);

  opretKonKnrOut = XtVaCreateManagedWidget(
					    "opretKonKnrOut",
					    labelWidgetClass,
					    opretKonForm,
					    XtNlabel, NUMBER,
					    XtNfromVert, opretKonNavnOut,
					    NULL);

  opretKonKnrIn = XtVaCreateManagedWidget(
					  "opretKonKnrIn",
					  asciiTextWidgetClass,
					  opretKonForm,
					  XtNeditType, XawtextEdit,
					  XtNwidth, KONTO_NR_LENGTH*6+3,
					  XtNfromHoriz, opretKonKnrOut,
					  XtNfromVert, opretKonNavnOut,
					  NULL);

  opretKonOk = XtVaCreateManagedWidget(
				       "opretKonOk",
				       commandWidgetClass,
				       opretKonForm,
				       XtNfromVert, opretKonKnrOut,
				       XtNlabel, CONFIRM_LABEL,
				       XtNwidth, BUTW,
				       NULL);
  
  opretKonCancel = XtVaCreateManagedWidget(
					   "opretKonCancel",
					   commandWidgetClass,
					   opretKonForm,
					   XtNfromVert, opretKonKnrOut,
					   XtNfromHoriz, opretKonOk,
					   XtNlabel, CANCEL_LABEL,
					   NULL);

  addOpretKontoCallBack();
}

void addOpretKontoCallBack(void) {
  XtAddCallback(opretKonCancel, XtNcallback, OpretKonCancel, topLevel);
  XtAddCallback(opretKonOk, XtNcallback, OpretKonOk, topLevel);
}

/* ========================================================== */     
void OpretKonPopup(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  Position x,y;
  Dimension width, height;

  createOpretKontoWidgets();

  XtTranslateCoords(topLevel, (Position)80, (Position)20,
		    &x, &y);
  
  XtVaSetValues(opretKonShell, XtNx, x,
		XtNy, y,
		NULL );
    
  XtSetSensitive(opretKonto,FALSE); 
  XtPopup(opretKonShell, XtGrabNone);
}

void OpretKonOk(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  char navn[128], knr[128], fil[128], dato[32];
  String p;
  time_t tid;
  struct tm *tidStruct;

  XtVaGetValues(opretKonFilIn, 
		XtNstring, &p,
		NULL); 

  zeroAddStrncpy(fil,p,127);

  XtVaGetValues(opretKonNavnIn, 
		XtNstring, &p,
		NULL); 

  zeroAddStrncpy(navn,p,127);

  XtVaGetValues(opretKonKnrIn, 
		XtNstring, &p,
		NULL); 

  zeroAddStrncpy(knr,p,127);

  if( strlen(fil)==0 || (strlen(navn)==0 && strlen(knr)==0) ) {
    xfError(MUST_FILL_FIELDS, NONFATAL,"create");
    return;
  }

  time(&tid);
  tidStruct=localtime(&tid);
  sprintf(dato, "%02d%02d%02d\n",    tidStruct->tm_year,
	  tidStruct->tm_mon+1, 
	  tidStruct->tm_mday );

  nyKonto(indxOfKontoSelection(),fil,navn,knr,dato);
  opdaterKontoList();

  XtPopdown(opretKonShell);
  XtSetSensitive(opretKonto, TRUE); 
}

void OpretKonCancel(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  XtPopdown(opretKonShell);
  XtSetSensitive(opretKonto, TRUE); 
}









