/* $Id: pante.c,v 2.1 1995/03/30 16:13:17 lupus Exp lupus $ */

#include <stdlib.h>
#include <string.h>
#include "xfinans.h"
#include "str.h"
#include "allocmem.h"

/* beregning af rente/afdrag paa amortisations-pantebreve */
/* tekst-format: rentefod,terminsstoerrelse. */

extern char *postString[];

long nextTermin(long termin) {  /* adderer 6 mnd. til datoen termin */
  int ar, md, da;
  ar=termin/10000;
  md=(termin-ar*10000)/100;
  da=termin-ar*10000-md*100;
  md+=6;
  if(md>12) {
    md-=12;
    ar++;
  }
/*  if(ar<1000)
    ar+=1900; */
  if(ar>=100)
    ar-=100;
  return ar*10000+md*100+da;
}
  
void renteTermin(char *post, double *rent, double *term) {
  char buf[256];
  char *termstr;
  int t=0;

  zeroAddStrncpy(buf,post,255);
  while(*(buf+t)!='\0' && *(buf+t)!=',')
    t++;
  termstr=buf+t+1;
  *(buf+t)='\0';
  *rent=atof(nocomma(buf));
  *term=atof(nocomma(termstr));
}

char **pantePostStrings(struct postering *p) {
  double rentefod, termin, rente, afdrag;
  long dato;
  double restgaeld;
  int i, j, si, k;
  char buf[256];

  renteTermin(p->tekst, &rentefod, &termin);
  restgaeld=p->bel;
  dato=p->dato;
  /* printf("%9.2f %9.2f %9.2f\n", rentefod, termin, restgaeld); */

  sprintf(buf, "Dato    Restgld   Rente      Afdrag     Termin   Ny restgld");
  postString[0]=(char *)AllocateMemory(strlen(buf)+1);
  strcpy(postString[0], buf);

  for(k=1;restgaeld>0.0 && k<200;k++) {
      sprintf(buf, "%06D  %9.2f", dato, restgaeld );
      rente=restgaeld*rentefod/200.0;  /* halvaarlig renteberegning */
      afdrag=termin-rente;
      /* printf("%06D  %9.2f  %9.2f  %9.2f\n", dato, restgaeld, rente, afdrag ); */
      restgaeld-=afdrag;
      if(restgaeld<0) {
	afdrag+=restgaeld;
	restgaeld=0;
	termin=rente+afdrag;
      }
      dato=nextTermin(dato);
      sprintf(buf+strlen(buf), " %9.2f  %9.2f  %9.2f  %9.2f", rente, afdrag, termin, restgaeld);
      postString[k]=(char *)AllocateMemory(strlen(buf)+1);
      strcpy(postString[k], buf);
  }
  return postString;
}
