/* $Id: search.c,v 2.2 1995/04/01 10:59:25 lupus Exp lupus $ */

#include <string.h>

#include "searchp.h"
#include "search.h"
#include "saldo.h"
#include "post.h"
#include "plot.h"
#include "xfError.h"
#include "country.h"
#include "str.h"

/* #include "reg.h" */

#define MAXLI 1000
#define SEA_BUTW 60

Widget searchShell, searchPane, searchBox2,
  searchTextOut, searchTextIn, searchViewp, searchList,
  searchOk, /* searchSaldoPopup, searchPlotPopup, renteTil, */
  searchClose;

static char *searchStr[MAXLI];
static int popup=0;

int searchIsPopup(void) {
  return popup;
}

searchInit(void) {
  int i;
  for(i=0; i<MAXLI; i++)
    searchStr[i]=0;
}

searchFree(void) {
  int i=0;
  while(searchStr[i] && i<MAXLI) {
    free(searchStr[i]);
    searchStr[i]=0;
    i++;
  }
}

void opdaterSearchList(void) {
  String p;
  char text[256];
  if(!popup)
    return;  

  XtVaGetValues(searchTextIn, 
		XtNstring, &p,
		NULL); 

  zeroAddStrncpy(text,p,255);

  /* strlower(text,text); */
  /* printf("%s\n", text); */
  /* regularCompile(text); */

  searchFree();
  XawListChange(searchList, searchStrings(searchStr,MAXLI,text), 0,0, TRUE);
}

void createSearchWidgets(void) {
  static int done=0;
  
  if(done)
    return;
  done=1;

  searchInit();

  /* regularCompile("xfinans"); */

  searchShell = XtVaCreatePopupShell (
				      "searchShell",
				      transientShellWidgetClass,
				      topLevel,
				      XtNtitle, FUNCTIONS_TITLE,
				      XtNx,0,
				      XtNy,130,
				      NULL );
  
  searchPane = XtVaCreateManagedWidget(
				       "searchPane",
				       panedWidgetClass,
				       searchShell,
				       XtNheight, 170,
				       XtNwidth, 430,
				       NULL);
  
  searchBox2 = XtVaCreateManagedWidget(
				   "searchBox2",
				   boxWidgetClass,
				   searchPane,
				   NULL);

  searchOk = XtVaCreateManagedWidget(
				 "searchOk",
				 commandWidgetClass,
				 searchBox2,
				 XtNlabel, SEARCH_LABEL,
				 XtNwidth, SEA_BUTW,
				 NULL);
  
  searchTextOut = XtVaCreateManagedWidget(
				 "searchTextOut",
				 labelWidgetClass,
				 searchBox2,
				 XtNlabel, SEARCH_EXPR,
				 NULL);
  
  searchTextIn = XtVaCreateManagedWidget(
				     "searchTextIn",
				     asciiTextWidgetClass,
				     searchBox2,
				     XtNeditType, XawtextEdit,
				     XtNwidth, 200,
				     /* XtNheight, 45,*/
				     NULL);

  searchClose = XtVaCreateManagedWidget(
				     "searchClose",
				     commandWidgetClass,
				     searchBox2,
				     XtNlabel, CLOSE,
				     XtNwidth, SEA_BUTW,
				     NULL);


  searchViewp = XtVaCreateManagedWidget(
                                  "searchViewp",
                                  viewportWidgetClass,
                                  searchPane,
                                  XtNheight, 65,
                                  /* XtNwidth, 220, */
                                  XtNallowVert, TRUE,
                                  NULL);
 
  searchList = XtVaCreateManagedWidget(
				       "searchList",
				       listWidgetClass,
				       searchViewp,
				       XtNlist, searchStrings(searchStr,MAXLI,""),
				       XtNheight, 65,
				       XtNdefaultColumns, 1,
				       XtNpasteBuffer, TRUE,
				       XtNforceColumns, TRUE,
  				       NULL);
  
  addSearchCallBack();
}

void addSearchCallBack(void) {
  XtAddCallback(searchClose, XtNcallback, SearchClose, topLevel);
  XtAddCallback(searchOk, XtNcallback, SearchOk, topLevel);
/*  XtAddCallback(searchSaldoPopup, XtNcallback, SaldoPopup, topLevel);
  XtAddCallback(searchPlotPopup, XtNcallback, PlotPopup, topLevel);
  XtAddCallback(renteTil, XtNcallback, Rente, topLevel);
*/
}

/* ========================================================== */     
void SearchPopup(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  if( !popup ) {
    createSearchWidgets();

    XtPopup(searchShell, XtGrabNone);
    popup=1;
    updateMarkWithText(SEARCH_LABEL,popup);
  }
  else {
    XtPopdown(searchShell);
    popup=0;
    updateMarkWithText(SEARCH_LABEL,popup);
  }
}

void SearchOk(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  String p;
  char text[256];

  XtVaGetValues(searchTextIn, 
		XtNstring, &p,
		NULL); 

  zeroAddStrncpy(text,p,255);

  if( strlen(text)==0 ) {
    xfError(ERR_NO_WORD, NONFATAL, "search");
    return;
  }

  /* strlower(text,text); */
  /* printf("%s\n", text); */
  /* regularCompile(text); */

  searchFree();
  XawListChange(searchList, searchStrings(searchStr,MAXLI,text), 0,0, TRUE);

}

void SearchClose(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  XtPopdown(searchShell);
  popup=0;
  updateMarkWithText(SEARCH_LABEL,popup);
}








