/* $Id: window.c,v 2.3 1995/04/01 10:59:25 lupus Exp lupus $ */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

#include "xfinans.h"
#include "window.h"
#include "konto.h"
#include "post.h"
#include "xfError.h"
#include "country.h"

#include "check.h"
#include "search.h"
#include "info.h"
#include "sletKonto.h"
#include "opretKonto.h"
#include "limitPost.h"
#include "datoPrint.h"
#include "icon.h"
#include "saldo.h"
#include "plot.h"
#include "str.h"
#include "flueben.h"

menu_item main_menu_names[] = {
  {PRINT,           1, 0, 0},
  {SEARCH_LABEL,    1, 1, 0},
  {INTEREST_LABEL,  1, 2, 0},
  {PLOT_LABEL,      1, 3, 0},
  {LIST_BALANCES,   1, 4, 0},
  {SHOW_COMMIT_BAL, COMMIT_SUPPORT, 5, 0},
  {ALL_POSTINGS,    1, 6, 0},
  {0,0,0,0}
};

menu_item printer_menu_names[] = {
  {POSTSCRIPT_LABEL, 1, 0, 0},
  {ASCII_TEXT_LABEL, 1, 1, 0},
  {0,0,0,0}
};

static Pixmap mark;

XtAppContext app_context;

Widget pshell, overfor, quit;    
Widget topLevel, vpane, buttonbox1, buttonbox2, 
/* viewports & lists: */
  kontoViewp, postViewp, kontoList, postList, 
  
/* kontoKnapper: */
  valgKonto, opretKonto, sletKontoKnap, 
  dagsDatoLabel,

/* opret konto-popup */
  opretKonShell,opretKonForm,opretKonFilOut,opretKonFilIn,
  opretKonNavnOut,opretKonNavnIn,opretKonKnrOut,opretKonKnrIn,
  opretKonOk,opretKonCancel,

/* slet Konto-bekr~ft: */
  sletKontoShell, sletKontoForm, 
  sletKontoOk, sletKontoCancel, sletKontoAsk,

/* posteringsKnapper: */
  nyPost, retPost, sletPost, 
#if COMMIT_SUPPORT
  commitPost, 
#endif
  mainMenuKnap, mainMenu, menuEntry,
  infoKnap,

/* bekraeft-slet-popup: */
  confirmShell, conform, confirm, confirmOk, confirmCancel, 

/* postering-popup: */
  posteringShell, posteringForm, 
  datoOut, datoIn, dagsDato, plusDato, minusDato, plusMon, minusMon,
  tekstOut, tekstIn, 
  belOut, belIn, 
  postOk, postCancel, postClear,

/* overfoer-popup: */
  ovfShell, ovfForm, 
  ovfFraTil,
  ovfdatoOut, ovfdatoIn, ovfDagsDato, 
  ovfPlusDato, ovfMinusDato, ovfPlusMon, ovfMinusMon,
  ovftekstOut, ovftekstIn, 
  ovfbelOut, ovfbelIn, 
  ovfOk, ovfCancel, ovfClearAll, ovfClearText, 

#if EXPERIMENTAL
  skrivCheck,
/* skrivCheck-popup */
  scShell, scForm, scDatoOut, scDatoIn,
  scTextIn, scBelOut, scBelIn,
  scOk, scCancel, 
#endif

/* udskriv-popup: */
  udsShell, udsDialog, udsOk, udsCancel, udsPrinter, 
/* printer-konfig-popup */
  printerConfigShell, printerConfigDialog, 
  printerConfigOk, printerConfigPS, printerMenu, 
/* rente-popup: */
  renteShell, renteForm,
  renteDato1Out, renteDato1In,
  renteDato2Out, renteDato2In,
  renteFod1Out,  renteFod1In,
  renteFod2Out,  renteFod2In,
  renteBeregn, renteResult,
  renteTilskriv, renteFortryd; 

static int whoIsPoping;     /* er det ny- eller retPost, der har gang i
			       popup-vinduet? */
int ovfFra=-1, ovfTil=-1;  /* index paa konti, der er valgt i kontoList,
				     ved to paa hinanden foelgende enkeltklik */
static int renteIsPopup=0, udsIsPopup=0;

void Quit(w, client_data, call_data)  /* funktionen der bliver kaldt
					 ved tryk paa "quit"-knappen */
Widget w;
XtPointer client_data, call_data;
{
  lukGnuplot();
  unlink("fplot.plt");
  unlink("xf.ps");
  exit(0);
}

/*************************  Menu-selection      **************************/

int main_menu_label_to_number(char *label) {
  int i;
  char *item;
  for(i=0; (item=main_menu_names[i].text)!=0; i++) {
    if(!strcmp(item,label))
      return i;
  }
  return -1;
}

void updateMark(Widget w, int set) {
  if(!w)
    return;
  if(set)
    XtVaSetValues(w, 
		  XtNleftBitmap, mark,
		  NULL);
  else
    XtVaSetValues(w, 
		  XtNleftBitmap, None,
		  NULL);
}

void updateMarkNumber(int number, int set) {
  updateMark(main_menu_names[number].button, set);
}

void updateMarkWithText(char *text, int set) {
  int i;
  i=main_menu_label_to_number(text);
  if(i<0)
    return;
  updateMarkNumber(i,set);
}

static void MenuSelect(w, client_data, garbage)
Widget w;
XtPointer client_data;
XtPointer garbage;  /* call_data */
{
  int pane_num = (int) client_data;
  
  switch(pane_num) {
  case 0:          /* PRINT */
    UdsPopup(w,client_data, garbage);
    break;
  case 1:          /* SEARCH */
    SearchPopup(w,client_data, garbage);
    break; 
  case 2:        /* INTEREST */
    Rente(w,client_data, garbage);
    break;
  case 3:        /* PLOT */
    PlotPopup(w,client_data, garbage);
    break;
  case 4:        /* LIST_BALANCES */
    SaldoPopup(w,client_data, garbage);
    break;
  case 5:
    updateMark(w,invertShowCommitted());
    opdaterPostList();
    break;
  case 6:
    LimitPost(w,client_data, garbage);
    updateMark(w,isViewLimited());
    break;
  default:
    break;
  }

/*  printf("Menu item %s has been selected.\n", XtName(w));
*/
}


/*************************  Action-funktioner   **************************/

static void DoQuit(w,event,params,num_params)
Widget w;
XButtonEvent *event;
String *params;
Cardinal *num_params;
{
  Quit(w,0,0);
}

static void doPlotPopup(w,event,params,num_params)
Widget w;
XButtonEvent *event;
String *params;
Cardinal *num_params;
{
  PlotPopup(NULL,NULL,NULL);
}

static void doSaldoPopup(w,event,params,num_params)
Widget w;
XButtonEvent *event;
String *params;
Cardinal *num_params;
{
  SaldoPopup(NULL,NULL,NULL);
}

static void doRentePopup(w,event,params,num_params)
Widget w;
XButtonEvent *event;
String *params;
Cardinal *num_params;
{
  Rente(NULL,NULL,NULL);
}

static void doInterceptReturn(w,event,params,num_params)
Widget w;
XButtonEvent *event;
String *params;
Cardinal *num_params;
{
/*
  String p;
  char text[256];

  XtVaGetValues(w, 
                XtNstring, &p,
                NULL); 

  zeroAddStrncpy(text,p,255);

  printf("Yep, return; %s\n", text);
*/
}

/************************  mainWindow-function  ***************************/

void mainWindow(argc, argv)
int argc;
char **argv;
{
  static XtActionsRec xf_actions[] = {
    {"doquit", DoQuit},
    {"plotpopup", doPlotPopup},
    {"interceptReturn", doInterceptReturn},
    {"saldopopup", doSaldoPopup},
    {"button_press", button1pressed}
  };

  int i;
  String item;

    /***********  Create vinduer, knapper, tekst, lister, 
                  scrollvinduer etc.etc. ****/

/* ===================  Top Level ===================*/
  topLevel = XtVaAppInitialize(
			       &app_context,
			       PNAME,
			       NULL, 0,
			       &argc, argv,
			       NULL,
			       NULL );
  
  vpane = XtVaCreateManagedWidget("vpane", panedWidgetClass, topLevel,
				  XtNwidth, S_WIDTH,
				  XtNheight, S_HEIGHT,
				  NULL);
  
  mark = XCreateBitmapFromData(XtDisplay(topLevel),
			       RootWindowOfScreen(XtScreen(topLevel)),
			       flueben_bits, flueben_width, flueben_height);

  buttonbox1 = XtCreateManagedWidget("buttonbox1", 
				     boxWidgetClass, 
				     vpane, 
				     NULL, 0);
  
  createXfinansIcon(topLevel);
  

/* ================= Konto-knapper ====================== */

  valgKonto = XtVaCreateManagedWidget(
				  "valgKonto",
				  commandWidgetClass,
				  buttonbox1,
				  XtNlabel, SELECT,
				  XtNwidth, KONTO_BUTW,
				  NULL);

  opretKonto = XtVaCreateManagedWidget(
				  "opretKonto",
				  commandWidgetClass,
				  buttonbox1,
				  XtNlabel, CREATE_ACCOUNT,
				  XtNwidth, KONTO_BUTW,
				  NULL);

  sletKontoKnap = XtVaCreateManagedWidget(
				  "sletKontoKnap",
				  commandWidgetClass,
				  buttonbox1,
				  XtNlabel, CLOSE_ACCOUNT,
				  XtNwidth, KONTO_BUTW,
				  NULL);

  overfor = XtVaCreateManagedWidget(
				  "overfor",
				  commandWidgetClass,
				  buttonbox1,
				  XtNlabel, TRANSFER,
				  NULL);

  quit = XtVaCreateManagedWidget(
				  "quit",
				  commandWidgetClass,
				  buttonbox1,
				  XtNlabel, QUIT,
				  XtNwidth, KONTO_BUTW,
				  NULL);

  dagsDatoLabel = XtVaCreateManagedWidget(
				  "dagsDatoLabel",
				  labelWidgetClass,
				  buttonbox1,
				  XtNlabel, datoPrint(),	
				  XtNfromHoriz, quit, 
				  XtNhorizDistance, 16,
				  XtNright, XtChainRight,
				  NULL);

/* =======================  Konto liste ============================  */

  kontoViewp = XtVaCreateManagedWidget(
				  "kontoViewp",
				  viewportWidgetClass,
				  vpane,
				  XtNheight, 65,
				  XtNwidth, 440,
				  XtNallowVert, TRUE,
				  NULL);
 
  kontoList = XtVaCreateManagedWidget(
				      "kontoList",
				      listWidgetClass,
				      kontoViewp,
				      XtNlist, kontoStrings(),
				      NULL);

/* ===================  PosteringsKnapper  =============================*/
  buttonbox2 = XtCreateManagedWidget("buttonbox2", 
                                      boxWidgetClass, 
                                      vpane, 
                                      NULL, 0);

  nyPost = XtVaCreateManagedWidget(
				  "nyPost",
				  commandWidgetClass,
				  buttonbox2,
				  XtNlabel, NEW_POSTING,
				  XtNwidth, POST_BUTW,
				  NULL);

  retPost = XtVaCreateManagedWidget(
				  "retPost",
				  commandWidgetClass,
				  buttonbox2,
				  XtNlabel, EDIT_POSTING,
				  XtNwidth, POST_BUTW,
				  NULL);

  sletPost = XtVaCreateManagedWidget(
				  "sletPost",
				  commandWidgetClass,
				  buttonbox2,
				  XtNlabel, DELETE_POSTING,
				  XtNwidth, POST_BUTW,
				  NULL);

#if COMMIT_SUPPORT
  commitPost = XtVaCreateManagedWidget(
				  "commitPost",
				  commandWidgetClass,
				  buttonbox2,
				  XtNlabel, COMMIT_POST_LABEL,
				  XtNwidth, POST_BUTW,
				  NULL);
#endif
  mainMenuKnap =  XtVaCreateManagedWidget(
					  "mainMenuKnap",
					  menuButtonWidgetClass,
					  buttonbox2,
					  XtNmenuName, "mainMenu",
					  XtNlabel, FUNCTIONS,
					  XtNwidth, POST_BUTW,
					  NULL);
  
  mainMenu = XtCreatePopupShell("mainMenu",
				simpleMenuWidgetClass,
				mainMenuKnap,
				NULL,0);

  for(i=0; (item=main_menu_names[i].text)!=0; i++) {
    if(main_menu_names[i].active) {
      menuEntry = main_menu_names[i].button = XtVaCreateManagedWidget(item, 
						 smeBSBObjectClass,
				                 mainMenu, 
						 XtNleftMargin, 30,
						 NULL);
      XtAddCallback(menuEntry, XtNcallback, MenuSelect, 
		    (XtPointer) main_menu_names[i].opcode);
    }
  }
  infoKnap = XtVaCreateManagedWidget(
				     "infoKnap",
				     commandWidgetClass,
				     buttonbox2,
				     XtNlabel, HELP,
				     XtNwidth, POST_BUTW,
				     NULL);

/* =======================  PosteringsListe ============================  */

  postViewp = XtVaCreateManagedWidget(
				      "postViewp",
				      viewportWidgetClass,
				      vpane,
				      XtNheight, 165,
				      XtNwidth, 440,
				      XtNallowVert, TRUE,
				      /*XtNforceBars, TRUE,*/
				      NULL);
  
  postList = XtVaCreateManagedWidget(
				     "postList",
				     listWidgetClass,
				     postViewp,
				     XtNlist, postStrings(),
				     XtNdefaultColumns, 1,
				     XtNforceColumns, TRUE,
				     XtNpasteBuffer, TRUE,
				     NULL);

  /* =================  Bekraeft slet-post =========================== */
  confirmShell = XtVaCreatePopupShell (
				       "confirmShell",
				       transientShellWidgetClass,
				       topLevel,
				       XtNtitle, WARNING_TITLE,
				       NULL );
  
  conform = XtVaCreateManagedWidget(
				    "conform",
				    formWidgetClass,
				    confirmShell,
				    NULL);
  
  confirm = XtVaCreateManagedWidget(
				    "confirm",
				    labelWidgetClass,
				    conform,
				    XtNlabel, WARNING_TEXT_POST,
				    NULL);

  confirmOk = XtVaCreateManagedWidget(
				      "confirmOk",
				      commandWidgetClass,
				      conform,
				      XtNlabel, CONFIRM_LABEL,
				      XtNwidth, BUTW,
				      XtNfromVert, confirm, 
				      NULL);
  
  confirmCancel = XtVaCreateManagedWidget(
					  "confirmCancel",
					  commandWidgetClass,
					  conform,
					  XtNlabel, CANCEL_LABEL,
					  XtNfromVert, confirm, 
					  XtNfromHoriz, confirmOk, 
					  NULL);
  
  
/*======================  Postering-Popup-vindue  ====================== */
  posteringShell = XtVaCreatePopupShell (
					 "posteringShell",
					 transientShellWidgetClass,
					 topLevel,
					 XtNtitle, POSTING_TITLE,
					 NULL );
  
  posteringForm = XtVaCreateManagedWidget(
					  "posteringForm",
					  formWidgetClass,
					  posteringShell,
					  NULL);
  
  datoOut = XtVaCreateManagedWidget(
				    "datoOut",
				    labelWidgetClass,
				    posteringForm,
				    XtNlabel, DATE,
				    NULL);

  datoIn = XtVaCreateManagedWidget(
				  "datoIn",
				   asciiTextWidgetClass,
				   posteringForm,
				   XtNeditType, XawtextEdit,
				   XtNwidth, 6*6+3,
				   XtNfromHoriz, datoOut,
				   NULL);
  
  dagsDato = XtVaCreateManagedWidget(
				     "dagsDato",
				     commandWidgetClass,
				     posteringForm,
				     XtNlabel, TODAY,
				     XtNfromHoriz, datoIn,
				     NULL);
  
  plusDato = XtVaCreateManagedWidget(
				     "plusDato",
				     commandWidgetClass,
				     posteringForm,
				     XtNlabel, INCR,
				     XtNfromHoriz, dagsDato,
				     NULL);
  
  minusDato = XtVaCreateManagedWidget(
				      "minusDato",
				      commandWidgetClass,
				      posteringForm,
				      XtNlabel, DECR,
				      XtNfromHoriz, plusDato,
				      NULL);
  
  plusMon = XtVaCreateManagedWidget(
				    "plusMon",
				    commandWidgetClass,
				    posteringForm,
				    XtNlabel, INCR_MONTH,
				    XtNfromHoriz, minusDato,
				    NULL);
  
  minusMon = XtVaCreateManagedWidget(
				     "minusMon",
				     commandWidgetClass,
				     posteringForm,
				     XtNlabel, DECR_MONTH,
				     XtNfromHoriz, plusMon,
				     NULL);
  
  tekstOut = XtVaCreateManagedWidget(
				     "tekstOut",
				     labelWidgetClass,
				     posteringForm,
				     XtNlabel, TEXT_LABEL,
				     XtNfromVert, datoIn,
				     NULL);
  
  tekstIn = XtVaCreateManagedWidget(
				    "tekstIn",
				    asciiTextWidgetClass,
				    posteringForm,
				    XtNeditType, XawtextEdit,
				    XtNwidth, POST_TEXT_LENGTH*6+3,
				    XtNfromHoriz, tekstOut,
				    XtNfromVert, datoIn,
				    NULL);
  
  belOut = XtVaCreateManagedWidget(
				   "belOut",
				   labelWidgetClass,
				   posteringForm,
				   XtNlabel, AMOUNT_LABEL,
				   XtNfromVert, tekstIn,
				   NULL);
  
  belIn = XtVaCreateManagedWidget(
				  "belIn",
				  asciiTextWidgetClass,
				  posteringForm,
				  XtNeditType, XawtextEdit,
				  XtNwidth, 10*6+3,
				  XtNfromHoriz, belOut,
				  XtNfromVert, tekstIn,
				  NULL);

  postOk = XtVaCreateManagedWidget(
				   "postOk",
				   commandWidgetClass,
				   posteringForm,
				   XtNlabel, CONFIRM_LABEL,
				   XtNwidth, BUTW,
				   XtNfromVert, belOut,
				   NULL);
  
  postCancel = XtVaCreateManagedWidget(
				       "postCancel",
				       commandWidgetClass,
				       posteringForm,
				       XtNlabel, CANCEL_LABEL,
				       XtNfromVert, belOut,
				       XtNfromHoriz, postOk,
				       NULL);
  
  postClear = XtVaCreateManagedWidget(
				      "postClear",
				      commandWidgetClass,
				      posteringForm,
				      XtNlabel, CLEAR_ALL,
				      XtNfromVert, belOut,
				      XtNfromHoriz, postCancel,
				      NULL);
  
/*======================  Overfoersel-Popup-vindue  ================ */
  ovfShell = XtVaCreatePopupShell (
				   "ovfShell",
				   transientShellWidgetClass,
				   topLevel,
				   XtNtitle, TRANSFER_TITLE,
				   NULL );
  
  ovfForm = XtVaCreateManagedWidget(
				    "ovfForm",
				    formWidgetClass,
				    ovfShell,
				    NULL);
  
  ovfFraTil = XtVaCreateManagedWidget(
				      "ovfFraTil",
				      labelWidgetClass,
				      ovfForm,
				      NULL);
  
  ovfdatoOut = XtVaCreateManagedWidget(
				       "ovfdatoOut",
				       labelWidgetClass,
				       ovfForm,
				       XtNlabel, DATE,
				       XtNfromVert, ovfFraTil,
				       NULL);
  
  ovfdatoIn = XtVaCreateManagedWidget(
				      "ovfdatoIn",
				      asciiTextWidgetClass,
				      ovfForm,
				      XtNeditType, XawtextEdit,
				      XtNwidth, 6*6+3,
				      XtNfromVert, ovfFraTil,
				      XtNfromHoriz, ovfdatoOut,
				      NULL);
  
  ovfDagsDato = XtVaCreateManagedWidget(
					"ovfDagsDato",
					commandWidgetClass,
					ovfForm,
					XtNlabel, TODAY,
					XtNfromVert, ovfFraTil,
					XtNfromHoriz, ovfdatoIn,
					NULL);
  
  ovfPlusDato = XtVaCreateManagedWidget(
					"ovfPlusDato",
					commandWidgetClass,
					ovfForm,
					XtNlabel, INCR,
					XtNfromVert, ovfFraTil,
					XtNfromHoriz, ovfDagsDato,
					NULL);
  
  ovfMinusDato = XtVaCreateManagedWidget(
					 "ovfMinusDato",
					 commandWidgetClass,
					 ovfForm,
					 XtNlabel, DECR,
					 XtNfromVert, ovfFraTil,
					 XtNfromHoriz, ovfPlusDato,
					 NULL);
  
  ovfPlusMon = XtVaCreateManagedWidget(
				       "ovfPlusMon",
				       commandWidgetClass,
				       ovfForm,
				       XtNlabel, INCR_MONTH,
				       XtNfromVert, ovfFraTil,
				       XtNfromHoriz, ovfMinusDato,
				       NULL);

  ovfMinusMon = XtVaCreateManagedWidget(
					"ovfMinusMon",
					commandWidgetClass,
					ovfForm,
					XtNlabel, DECR_MONTH,
					XtNfromVert, ovfFraTil,
					XtNfromHoriz,
					ovfPlusMon,
					NULL);

  ovftekstOut = XtVaCreateManagedWidget(
					"ovftekstOut",
					labelWidgetClass,
					ovfForm,
					XtNlabel, TEXT_LABEL,
					XtNfromVert, ovfdatoIn,
					NULL);
  
  ovftekstIn = XtVaCreateManagedWidget(
				       "ovftekstIn",
				       asciiTextWidgetClass,
				       ovfForm,
				       XtNeditType, XawtextEdit,
				       XtNwidth, POST_TEXT_LENGTH*6+3,
				       XtNfromVert, ovfdatoIn,
				       XtNfromHoriz, ovftekstOut,
				       NULL);
  
  ovfbelOut = XtVaCreateManagedWidget(
				      "ovfbelOut",
				      labelWidgetClass,
				      ovfForm,
				      XtNlabel, AMOUNT_LABEL,
				      XtNfromVert, ovftekstIn,
				      NULL);
  
  ovfbelIn = XtVaCreateManagedWidget(
				     "ovfbelIn",
				     asciiTextWidgetClass,
				     ovfForm,
				     XtNeditType, XawtextEdit,
				     XtNwidth, 10*6+3,
				     XtNfromVert, ovftekstIn,
				     XtNfromHoriz, ovfbelOut,
				     NULL);
  
  ovfOk = XtVaCreateManagedWidget(
				  "ovfOk",
				  commandWidgetClass,
				  ovfForm,
				  XtNlabel, CONFIRM_LABEL,
				  XtNwidth, BUTW,
				  XtNfromVert, ovfbelOut,
				  NULL);

  ovfCancel = XtVaCreateManagedWidget(
				      "ovfCancel",
				      commandWidgetClass,
				      ovfForm,
				      XtNlabel, CANCEL_LABEL,
				      XtNfromVert, ovfbelOut,
				      XtNfromHoriz, ovfOk,
				      NULL);

  ovfClearAll = XtVaCreateManagedWidget(
				  "ovfClearAll",
				  commandWidgetClass,
				  ovfForm,
				  XtNlabel, CLEAR_ALL,
				  XtNfromVert, ovfbelOut,
				  XtNfromHoriz, ovfCancel,
				  NULL);

  ovfClearText = XtVaCreateManagedWidget(
				  "ovfClearText",
				  commandWidgetClass,
				  ovfForm,
				  XtNlabel, CLEAR_TEXT,
				  XtNfromVert, ovfbelOut,
				  XtNfromHoriz, ovfClearAll,
				  NULL);

#if EXPERIMENTAL
  skrivCheck = XtVaCreateManagedWidget(
				  "skrivCheck",
				  commandWidgetClass,
				  ovfForm,
				  XtNlabel, "Udskriv Check",
				  XtNfromVert, ovfbelOut,
				  XtNfromHoriz, ovfClearText,
				  NULL);
#endif

/* =======================  Udskriv PopUP ==================*/
  udsShell = XtVaCreatePopupShell (
				 "udsShell",
				 transientShellWidgetClass,
				 topLevel,
				 XtNtitle, PRINT_TITLE,
				 NULL );

  udsDialog = XtVaCreateManagedWidget(
				  "udsDialog",
				  dialogWidgetClass,
				  udsShell,
				  XtNvalue, "",
				  XtNlabel, PRINT_FROM_LABEL, 
				  NULL);

  udsOk = XtVaCreateManagedWidget(
				  "udsOk",
				  commandWidgetClass,
				  udsDialog,
				  XtNlabel, CONFIRM_LABEL,
				  XtNwidth, BUTW,
				  NULL);

  udsCancel = XtVaCreateManagedWidget(
				  "udsCancel",
				  commandWidgetClass,
				  udsDialog,
				  XtNlabel, CANCEL_LABEL,
				  NULL);

  udsPrinter = XtVaCreateManagedWidget(
				  "udsPrinter",
				  commandWidgetClass,
				  udsDialog,
				  XtNlabel, PRINTER_LABEL,
				  NULL);

/* ==============  Printer-konfiguration ========================= */

  printerConfigShell = XtVaCreatePopupShell (
				 "printerConfigShell",
				 transientShellWidgetClass,
				 topLevel,
				 XtNtitle, PRINTER_CONFIG_TITLE,
				 NULL );

  printerConfigDialog = XtVaCreateManagedWidget(
				  "printerConfigDialog",
				  dialogWidgetClass,
				  printerConfigShell,
				  XtNvalue, "lp",
				  XtNlabel, DEFAULT_PRINTER_LABEL, 
				  NULL);

  printerConfigOk = XtVaCreateManagedWidget(
					    "printerConfigOk",
					    commandWidgetClass,
					    printerConfigDialog,
					    XtNlabel, CONFIRM_LABEL,
					    XtNwidth, BUTW,
					    NULL);
  
  printerConfigPS = XtVaCreateManagedWidget(
					    "printerConfigPS",
					    menuButtonWidgetClass,
					    printerConfigDialog,
					    XtNmenuName, "printerTypeMenu",
					    XtNlabel, PRINTER_TYPE_LABEL,
					    /* XtNwidth, POST_BUTW, */
					    NULL);

  printerMenu = XtCreatePopupShell("printerTypeMenu",
				   simpleMenuWidgetClass,
				   printerConfigPS,
				   NULL,0);
  
  for(i=0; (item=printer_menu_names[i].text)!=0; i++) {
    if(printer_menu_names[i].active) {
      menuEntry = printer_menu_names[i].button 
	        = XtVaCreateManagedWidget(item, 
					  smeBSBObjectClass,
					  printerMenu, 
					  XtNleftMargin, 30,
					  NULL);
      XtAddCallback(menuEntry, XtNcallback, PrinterConfigPS, 
		    (XtPointer) printer_menu_names[i].opcode);
    }
  }
  updateMark(printer_menu_names[1].button,1);

/*======================  Rente-Popup-vindue  ====================== */
  renteShell = XtVaCreatePopupShell (
				 "renteShell",
				 transientShellWidgetClass,
				 topLevel,
				 XtNtitle, INTEREST_TITLE,
				 NULL );

  renteForm = XtVaCreateManagedWidget(
				  "renteForm",
				  formWidgetClass,
				  renteShell,
				  NULL);

  renteDato1Out = XtVaCreateManagedWidget(
				  "renteDato1Out",
				  labelWidgetClass,
				  renteForm,
				  XtNlabel, FROM_DATE, 
				  NULL);

  renteDato1In = XtVaCreateManagedWidget(
				  "renteDato1In",
				  asciiTextWidgetClass,
				  renteForm,
				  XtNeditType, XawtextEdit,
				  XtNwidth, 6*6+3,	
				  XtNfromHoriz, renteDato1Out,
				  NULL);

  renteDato2Out = XtVaCreateManagedWidget(
				  "renteDato2Out",
				  labelWidgetClass,
				  renteForm,
				  XtNfromVert,renteDato1Out,
				  XtNlabel, TO_DATE, 
				  NULL);

  renteDato2In = XtVaCreateManagedWidget(
				  "renteDato2In",
				  asciiTextWidgetClass,
				  renteForm,
				  XtNeditType, XawtextEdit,
				  XtNwidth, 6*6+3,
				  XtNfromVert,renteDato1In,
				  XtNfromHoriz, renteDato2Out,
				  NULL);

  renteFod1Out = XtVaCreateManagedWidget(
				  "renteFod1Out",
				  labelWidgetClass,
				  renteForm,
				  XtNlabel, INTEREST_RATE_POSITIVE, 
				  XtNfromHoriz, renteDato1In,
				  NULL);

  renteFod1In = XtVaCreateManagedWidget(
				  "renteFod1In",
				  asciiTextWidgetClass,
				  renteForm,
				  XtNeditType, XawtextEdit,
				  XtNwidth, 6*6+3,
				  XtNfromHoriz, renteFod1Out,
				  NULL);

  renteFod2Out = XtVaCreateManagedWidget(
				  "renteFod2Out",
				  labelWidgetClass,
				  renteForm,
				  XtNfromVert,renteFod1Out,
				  XtNfromHoriz, renteDato2In,
				  XtNlabel, INTEREST_RATE_NEGATIVE, 
				  NULL);

  renteFod2In = XtVaCreateManagedWidget(
				  "renteFod2In",
				  asciiTextWidgetClass,
				  renteForm,
				  XtNeditType, XawtextEdit,
				  XtNwidth, 6*6+3,
				  XtNfromVert,renteFod1In,
				  XtNfromHoriz, renteFod2Out,
				  NULL);

  renteBeregn = XtVaCreateManagedWidget(
				  "renteBeregn",
				  commandWidgetClass,
				  renteForm,
				  XtNlabel, INTEREST_COMPUTE, 
				  XtNfromVert, renteDato2Out,
				  NULL);

  renteResult = XtVaCreateManagedWidget(
				  "renteResult",
				  labelWidgetClass,
				  renteForm,
				  XtNlabel, "", 
				  XtNfromVert, renteBeregn,
				  NULL);

  renteTilskriv = XtVaCreateManagedWidget(
				  "renteTilskriv",
				  commandWidgetClass,
				  renteForm,
				  XtNlabel, INTEREST_ADD, 
				  XtNfromVert, renteResult,
				  NULL);

  renteFortryd = XtVaCreateManagedWidget(
				  "renteFortryd",
				  commandWidgetClass,
				  renteForm,
				  XtNlabel, CANCEL_LABEL, 
				  XtNfromVert, renteResult,
				  XtNfromHoriz, renteTilskriv,
				  NULL);

  createLimitPostWidgets();   /* lav postering-begraensnings-knap */

/* ************************  Registrer callbacks **************************/
/*          Dvs. foerst og fremmest at knytte funktioner til knapperne  */

  XtAddCallback(quit, XtNcallback, Quit, 0);
  XtAddCallback(valgKonto, XtNcallback, ValgKontoCallBack, topLevel);
  XtAddCallback(kontoList, XtNcallback, KontoListSelectionCallBack, topLevel);

  XtAddCallback(sletKontoKnap, XtNcallback, SletKontoPopup, topLevel);
  XtAddCallback(opretKonto, XtNcallback, OpretKonPopup, topLevel);
  XtAddCallback(sletPost, XtNcallback, SletPostPopup, topLevel);
#if COMMIT_SUPPORT
  XtAddCallback(commitPost, XtNcallback, CommitCallback, topLevel);
#endif
  XtAddCallback(renteFortryd, XtNcallback, RenteFortryd, topLevel);
  XtAddCallback(renteBeregn, XtNcallback, RenteBeregn, topLevel);
  XtAddCallback(renteTilskriv, XtNcallback, RenteTilskriv, topLevel);

  XtAddCallback(udsOk, XtNcallback, UdsOk, topLevel);
  XtAddCallback(udsCancel, XtNcallback, UdsCancel, topLevel);

  XtAddCallback(udsPrinter, XtNcallback, PrinterConfigPopup, topLevel);
  XtAddCallback(printerConfigOk, XtNcallback, PrinterConfigOk, topLevel);
  XtAddCallback(confirmOk, XtNcallback, SletPostConfirm, confirm);
  XtAddCallback(confirmCancel, XtNcallback, SletPostCancel, confirm);
  
  XtAddCallback(nyPost, XtNcallback, PosteringPopup, (Widget)NYPOST);
  XtAddCallback(retPost, XtNcallback, PosteringPopup, (Widget)RETPOST);
  XtAddCallback(postOk, XtNcallback, PostConfirm, topLevel);
  XtAddCallback(postCancel, XtNcallback, PostCancel, topLevel);
  XtAddCallback(postClear, XtNcallback, PostClear, topLevel);
  XtAddCallback(dagsDato, XtNcallback, DagsDato, datoIn);
  XtAddCallback(plusDato, XtNcallback, PlusDato, datoIn);
  XtAddCallback(minusDato, XtNcallback, MinusDato, datoIn);
  XtAddCallback(plusMon, XtNcallback, PlusMon, datoIn);
  XtAddCallback(minusMon, XtNcallback, MinusMon, datoIn);

  XtAddCallback(ovfDagsDato, XtNcallback, DagsDato, ovfdatoIn);
  XtAddCallback(ovfPlusDato, XtNcallback, PlusDato, ovfdatoIn);
  XtAddCallback(ovfMinusDato, XtNcallback, MinusDato, ovfdatoIn);
  XtAddCallback(ovfPlusMon, XtNcallback, PlusMon, ovfdatoIn);
  XtAddCallback(ovfMinusMon, XtNcallback, MinusMon, ovfdatoIn);

  XtAddCallback(overfor, XtNcallback, OvfPopup, topLevel);
  XtAddCallback(ovfOk, XtNcallback, OvfConfirm, topLevel);
  XtAddCallback(ovfCancel, XtNcallback, OvfCancel, topLevel);
  XtAddCallback(ovfClearAll, XtNcallback, OvfClearAll, topLevel);
  XtAddCallback(ovfClearText, XtNcallback, OvfClearText, topLevel);
#if EXPERIMENTAL
  XtAddCallback(skrivCheck, XtNcallback, ScPopup, topLevel); 
#endif
  XtAddCallback(infoKnap, XtNcallback, InfoPopup, topLevel); 

/*************  Bring hoved-vinduet frem og lad X klare resten *************/

  XtAppAddActions(app_context, xf_actions, XtNumber(xf_actions)); 

  XtRealizeWidget(topLevel);

  XtInstallAccelerators(vpane, quit);   /* definer "hot-key" for quit */

  XtAppMainLoop(app_context);
}

/* ====================  Konto-CallBacks ========================== */

int indxOfKontoSelection(void) {      /* returnerer -1, hvis ingen er valgt */
  XawListReturnStruct *res;
  res=XawListShowCurrent(kontoList);
  if( res->list_index==XAW_LIST_NONE )
    return -1;
  else
    return res->list_index;
}

void opdaterPostList(void) {
  opdaterSearchList();
  XawListChange(postList, postStrings(), 0,0, TRUE);
}

void opdaterKontoList(void) {
  XawListChange(kontoList, kontoStrings(), 0,0, TRUE);
}

static void ValgKontoCallBack(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  int i;
  i=indxOfKontoSelection();
  if(i<0) {
    xfError(ERR_DO_CLICK, NONFATAL, "open");
    return;
  }
  loadKonto(i);
  addKontoToList(i);  /* tilbyd den valgte konto til listen i
	                 	"vis-saldo" vinduet. */
  opdaterPostList();
}

static void KontoListSelectionCallBack(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  static int indx=-1, npress=0;
  int i;
  i=indxOfKontoSelection();
  if(i<0)
    return;

  ovfFra=ovfTil;
  ovfTil=i;

  if( i==indx ) {
    npress=2;
  }
  else {
    indx=i;
    npress=1;
  }

  if( npress==2 ) {
    npress=0;
    indx=-1;
    loadKonto(i);
    opdaterPostList();
  }
}

/* =================== Post-CallBacks ===================== */

int indxOfPostSelection(void) {      /* returnerer -1, hvis ingen er valgt */
  XawListReturnStruct *res;
  res=XawListShowCurrent(postList);
  if( res->list_index==XAW_LIST_NONE )
    return -1;
  else
    return res->list_index;
}

/* ==== slet-post-confirm-callbacks ====  */

void SletPostPopup(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  Position x,y;
  Dimension width, height;
  int i;
  
  i=indxOfPostSelection();
  if( i<0 ) {
    xfError(ERR_DO_CLICK_POSTING, NONFATAL, "delete ");
    return;
  }

  XtTranslateCoords(topLevel,(Position)100, (Position)100,
		    &x, &y);

  XtVaSetValues(confirmShell, XtNx, x,
		XtNy, y,
		NULL );
  XtSetSensitive(sletPost,FALSE); 
  XtPopup(confirmShell, XtGrabNonexclusive);
}

void SletPostConfirm(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  int i;
  i=indxOfPostSelection();
  if( i<0 ) {
    xfError(ERR_DO_CLICK_POSTING, NONFATAL, "delete ");
    return;
  }

  XtPopdown(confirmShell);
  XtSetSensitive(sletPost, TRUE); 

  okSletPost(i);
  saveKonto();
  opdaterPostList();
}

void SletPostCancel(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  XtPopdown(confirmShell);
  XtSetSensitive(sletPost, TRUE);
}

/* ======== postering-popup-vindue-callback ========== */

void PosteringPopup(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  int i;

  i=aktKonto();
  if( i<0 ) {
    xfError(ERR_DO_SELECT, NONFATAL, "do select");
    return;
  }

  i=(int) client_data;
  switch(i) {
	case NYPOST:
	  whoIsPoping=NYPOST;
	  NyPostCallBack(w, client_data, call_data);
	  break;
	case RETPOST:
	  whoIsPoping=RETPOST;
	  RetPostCallBack(w, client_data, call_data);
	  break;
  }
}

void NyPostCallBack(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  Position x,y;
  Dimension width, height;
  int i;
  char dato[32], text[POST_TEXT_LENGTH], bel[32];

  i=indxOfPostSelection();
  if( i>=0 ) {
    getPostAsText(i, dato, text, bel);
    XtVaSetValues(datoIn,	
		  XtNstring, dato,
		  NULL);
    
    XtVaSetValues(tekstIn,	
		  XtNstring, text,
		  NULL);
    
    XtVaSetValues(belIn,	
		  XtNstring, bel,
		  NULL);
  }    
  XtTranslateCoords(topLevel,(Position)100, (Position)50,
		    &x, &y);
  
  XtVaSetValues(posteringShell, XtNx, x,
		XtNy, y,
		NULL );
  
  XtSetSensitive(nyPost,FALSE); 
  XtPopup(posteringShell, XtGrabNone);
}

void PostConfirm(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  switch(whoIsPoping) {
  case NYPOST:
    NyPostConfirm(w, client_data, call_data);
    break;
  case RETPOST:
    RetPostConfirm(w, client_data, call_data);
    break;
  }
}

void PostCancel(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  switch(whoIsPoping) {
	case NYPOST:
	  NyPostCancel(w, client_data, call_data);
	  break;
	case RETPOST:
	  RetPostCancel(w, client_data, call_data);
	  break;
  }
}

void NyPostConfirm(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  char dato[128], text[128], bel[128];
  String p;

  XtVaGetValues(datoIn, 
		XtNstring, &p,
		NULL); 

  zeroAddStrncpy(dato,p,127);

  XtVaGetValues(tekstIn, 
		XtNstring, &p,
		NULL); 

  zeroAddStrncpy(text,p,127);

  XtVaGetValues(belIn, 
		XtNstring, &p,
		NULL); 

  zeroAddStrncpy(bel,p,127);

  if( strlen(dato)==0 || strlen(bel)==0 ) {
    xfError(MUST_FILL_FIELDS, NONFATAL,"new");
    return;
  }

  XtPopdown(posteringShell);
  XtSetSensitive(nyPost, TRUE); 

  okNyPost(0,dato, text, bel);
  saveKonto();
  opdaterPostList(); 
}

void NyPostCancel(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  XtPopdown(posteringShell);
  XtSetSensitive(nyPost, TRUE);
}

void PostClear(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  XtVaSetValues(datoIn, 
		XtNstring, "",
		NULL); 

  XtVaSetValues(tekstIn, 
		XtNstring, "",
		NULL); 

  XtVaSetValues(belIn, 
		XtNstring, "",
		NULL);   
}

void DagsDato(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  time_t tid;
  struct tm *tidStruct;
  char datoT[32];
  Widget putIn;

  putIn=(Widget) client_data;

  time(&tid);
  tidStruct=localtime(&tid);
  sprintf(datoT, "%02d%02d%02d\n",    tidStruct->tm_year,
				tidStruct->tm_mon+1, 
				tidStruct->tm_mday );

  XtVaSetValues(putIn, 
		XtNstring, datoT,
		NULL); 
}

void PlusDato(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  char datoT[32];
  Widget putIn;
  String p;
  long datoTal;

  putIn=(Widget) client_data;


  XtVaGetValues(putIn, 
		XtNstring, &p,
		NULL); 

  datoTal=atoi(p);
  datoSkriv(datoT, incr(datoTal));

  XtVaSetValues(putIn, 
		XtNstring, datoT,
		NULL); 
}

void MinusDato(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  char datoT[32];
  Widget putIn;
  String p;
  long datoTal;

  putIn=(Widget) client_data;


  XtVaGetValues(putIn, 
		XtNstring, &p,
		NULL); 

  datoTal=atoi(p);
  datoSkriv(datoT, decr(datoTal));

  XtVaSetValues(putIn, 
		XtNstring, datoT,
		NULL); 
}

void PlusMon(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  char datoT[32];
  Widget putIn;
  String p;
  long datoTal;

  putIn=(Widget) client_data;

  XtVaGetValues(putIn, 
		XtNstring, &p,
		NULL); 

  datoTal=atoi(p);
  datoSkriv(datoT, incrMon(datoTal));

  XtVaSetValues(putIn, 
		XtNstring, datoT,
		NULL); 
}

void MinusMon(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  char datoT[32];
  Widget putIn;
  String p;
  long datoTal;

  putIn=(Widget) client_data;

  XtVaGetValues(putIn, 
		XtNstring, &p,
		NULL); 

  datoTal=atoi(p);
  datoSkriv(datoT, decrMon(datoTal));

  XtVaSetValues(putIn, 
		XtNstring, datoT,
		NULL); 
}

/* =================== Overfoering-CallBacks ===================== */

void makePos(char *s) {
  int t=0;
  if(*s!='-')
    return;
  while( *(s+t) ) {
     *(s+t)=*(s+ ++t);
  }
}

/* ======== overfoering-popup-vindue-callback ========== */

void OvfPopup(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  int i;
  char fratil[256];
  Position x,y;
  Dimension width, height;
  char dato[32], text[POST_TEXT_LENGTH], bel[32];
  
  if( ovfFra<0 || ovfTil<0 || ovfFra==ovfTil ) {
    xfError(ERR_DO_TWO_CLICK, NONFATAL,"transfer");
    return;
  }
  sprintf(fratil, "%s %s %s", TRANSFER_FROM, getKontoName(ovfFra), 
					   getKontoNr(ovfFra) );
  sprintf(fratil+strlen(fratil), "\n%s %s %s", TRANSFER_TO, 
						getKontoName(ovfTil), 
					        getKontoNr(ovfTil) );

  XtTranslateCoords(topLevel,(Position)100, (Position)50,
		    &x, &y);

  XtVaSetValues(ovfShell, XtNx, x,
		XtNy, y,
		NULL );

  XtVaSetValues(ovfFraTil, 
	 	XtNlabel, fratil,
		XtNwidth, (7+POST_TEXT_LENGTH)*6,
		NULL);

  i=indxOfPostSelection();
  if( i>=0 ) {
    getPostAsText(i, dato, text, bel);
    makePos(bel);
    XtVaSetValues(ovfdatoIn,	
		  XtNstring, dato,
		  NULL);
    
    XtVaSetValues(ovftekstIn,	
		  XtNstring, text,
		  NULL);
    
    XtVaSetValues(ovfbelIn,	
		  XtNstring, bel,
		  NULL);
  }    

  XtSetSensitive(overfor,FALSE); 
  XtPopup(ovfShell, XtGrabNone);
}

void OvfConfirm(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  char dato[128], text[128], bel[128], negBel[128];
  String p;

  negBel[0]='-';
  negBel[1]='\0';

  XtVaGetValues(ovfdatoIn, 
		XtNstring, &p,
		NULL); 

  zeroAddStrncpy(dato,p,127);

  XtVaGetValues(ovftekstIn, 
		XtNstring, &p,
		NULL); 

  zeroAddStrncpy(text,p,127);

  XtVaGetValues(ovfbelIn, 
		XtNstring, &p,
		NULL); 

  zeroAddStrncpy(bel,p,127);

  if( strlen(dato)==0 || strlen(bel)==0 ) {
    xfError(MUST_FILL_FIELDS, NONFATAL, "transfer");
    return;
  }

  XtPopdown(ovfShell);
  XtSetSensitive(overfor, TRUE); 

  if( strlen(text)==0 ) {
	sprintf(text, "%s %s (%s)", TRANSFER_TO_TEXT, getKontoName(ovfTil), 
					  getKontoNr(ovfTil) );
	strcat(negBel, bel);
	loadKonto(ovfFra);
  	okNyPost(0,dato, text, negBel);
	calculateCurrentSaldo();
	saveKonto();

	sprintf(text, "%s %s (%s)", TRANSFER_FROM_TEXT, getKontoName(ovfFra), 
					  getKontoNr(ovfFra) );
	loadKonto(ovfTil);
  	okNyPost(0,dato, text, bel);
	saveKonto();
  }
  else {
	loadKonto(ovfFra);
  	okNyPost(0,dato, text, bel);  /* NB! hvis der er tekst, regnes
					beloebet positivt i begge konti */
	calculateCurrentSaldo();
	saveKonto();

	loadKonto(ovfTil);
  	okNyPost(0,dato, text, bel);
	saveKonto();
  }
  opdaterPostList();
}

void OvfCancel(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  XtPopdown(ovfShell);
  XtSetSensitive(overfor, TRUE);
}

void OvfClearAll(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  XtVaSetValues(ovfdatoIn, 
		XtNstring, "",
		NULL); 

  XtVaSetValues(ovftekstIn, 
		XtNstring, "",
		NULL); 

  XtVaSetValues(ovfbelIn, 
		XtNstring, "",
		NULL);   
}

void OvfClearText(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  XtVaSetValues(ovftekstIn, 
		XtNstring, "",
		NULL); 
}

/* =================== Ret-Post-CallBacks ===================== */

void RetPostCallBack(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  Position x,y;
  Dimension width, height;
  int i;
  char dato[32], text[POST_TEXT_LENGTH], bel[128];

  i=indxOfPostSelection();
  if( i<0 ) {
    xfError(ERR_DO_CLICK_POSTING, NONFATAL, "edit");
    return;
  }

  getPostAsText(i, dato, text, bel);
  XtVaSetValues(datoIn,	
		XtNstring, dato,
		NULL);

  XtVaSetValues(tekstIn,	
		XtNstring, text,
		NULL);

  XtVaSetValues(belIn,	
		XtNstring, bel,
		NULL);

  XtTranslateCoords(topLevel,(Position)100, (Position)50,
		    &x, &y);

  XtVaSetValues(posteringShell, XtNx, x,
		XtNy, y,
		NULL );

  XtSetSensitive(retPost,FALSE); 
  XtPopup(posteringShell, XtGrabNone);
}

void RetPostConfirm(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  char dato[128], text[128], bel[128];
  int nyindx, indx;
  String p;

  indx=indxOfPostSelection();
  if( indx<0 )
    xfError(ERR_SHOULDNT_HAPPEN, FATAL, "edit");

  XtVaGetValues(datoIn, 
		XtNstring, &p,
		NULL); 

  zeroAddStrncpy(dato,p,127);

  XtVaGetValues(tekstIn, 
		XtNstring, &p,
		NULL); 

  zeroAddStrncpy(text,p,127);

  XtVaGetValues(belIn, 
		XtNstring, &p,
		NULL); 

  zeroAddStrncpy(bel,p,127);

  if( strlen(dato)==0 || strlen(bel)==0 ) {
    xfError(MUST_FILL_FIELDS, NONFATAL, "edit");
    return;
  }

  XtPopdown(posteringShell);
  XtSetSensitive(retPost, TRUE); 

  okRetPost(indx, dato, text, bel);
  saveKonto();
  opdaterPostList(); 
}

void RetPostCancel(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  XtPopdown(posteringShell);
  XtSetSensitive(retPost, TRUE);
}

/* =======================  Udskriv-callback ====================== */

void UdsPopup(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  Position x,y;
  int i;

  if( udsIsPopup ) {
    udsIsPopup=0;
    updateMarkWithText(PRINT,udsIsPopup);
    XtPopdown(udsShell);
    return;
  }
  
  i=aktKonto();
  if( i<0 ) {
    xfError(ERR_DO_SELECT, NONFATAL, "print");
    return;
  }
  if( aktKontoType()!=ALM ) {
    xfError(ERR_CANT_PRINT, NONFATAL, "can't print");
    return;
  }

  XtTranslateCoords(topLevel, 100, 50,
		    &x, &y);

  XtVaSetValues(udsShell, 
		XtNx, x,
		XtNy, y,
		NULL );
  udsIsPopup=1;
  updateMarkWithText(PRINT,udsIsPopup);
  XtPopup(udsShell, XtGrabNone);
}

void UdsOk(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  String string;
  long dato;

  string=XawDialogGetValueString(udsDialog);
  dato=atoi(string);

  udsIsPopup=0;
  updateMarkWithText(PRINT,udsIsPopup);
  XtPopdown(udsShell);

  udskriv(dato);
}

void UdsCancel(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  udsIsPopup=0;
  updateMarkWithText(PRINT,udsIsPopup);
  XtPopdown(udsShell);
}

/* =======================  Printer-config-callback ====================== */

void PrinterConfigPopup(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  Position x,y;

  XtVaGetValues(udsPrinter, 
		XtNx, &x,
		XtNy, &y,
		NULL); 

  XtTranslateCoords(topLevel, x+10, y+20,
		    &x, &y);

  XtVaSetValues(printerConfigShell, 
		XtNx, x,
		XtNy, y,
		NULL );

  XtSetSensitive(udsPrinter,FALSE); 
  XtPopup(printerConfigShell, XtGrabNone);
}

void PrinterConfigOk(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  String string;
  static char buf[30];

  string=XawDialogGetValueString(printerConfigDialog);
  zeroAddStrncpy(buf,string,29);

  selectPrinter(buf);

  XtPopdown(printerConfigShell);
  XtSetSensitive(udsPrinter, TRUE); 
}

/* void PrinterConfigCancel(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  XtPopdown(printerConfigShell);
  XtSetSensitive(udsPrinter, TRUE); 
}
*/

void PrinterConfigPS(w, client_data, garbage)
Widget w;
XtPointer client_data, garbage;
{
  int selection;

  selection=(int) client_data;
  /* printf("%d\n", (int) client_data); */

  switch(selection) {
  case 0:
    while(!switchPS()) 
      ;
    XtVaSetValues(printerConfigDialog,
		  XtNlabel, "Printer:     type PS",
		  NULL);
    updateMark(printer_menu_names[0].button,1);
    updateMark(printer_menu_names[1].button,0);
    break;
  case 1:
    while(switchPS()) 
      ;
    XtVaSetValues(printerConfigDialog,
		  XtNlabel, "Printer:     type text",
		  NULL);
    updateMark(printer_menu_names[0].button,0);
    updateMark(printer_menu_names[1].button,1);
    break;
  default:
    break;
  }
  
}


/* ======== rente-popup-vindue-callback ========== */
void Rente(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  Position x,y;
  Dimension width, height;
  int i;

  if(renteIsPopup) {
    renteIsPopup=0;
    updateMarkWithText(INTEREST_LABEL,renteIsPopup);
    XtPopdown(renteShell);
    return;
  }
  i=aktKonto();
  if( i<0 ) {
    xfError(ERR_DO_SELECT, NONFATAL, "interest");
    return;
  }
  if( aktKontoType()!=ALM ) {
    xfError(ERR_CANT_INTEREST, NONFATAL, "contents");
    return;
  }

  XtTranslateCoords(topLevel,(Position)60, (Position)120,
		    &x, &y);

  XtVaSetValues(renteShell, XtNx, x,
		XtNy, y,
		NULL );

  XtVaSetValues(renteResult,
		XtNwidth, (POST_TEXT_LENGTH+6+2+2+9)*6+3,
		NULL );

  XtSetSensitive(renteTilskriv,FALSE); 

  renteIsPopup=1;
  updateMarkWithText(INTEREST_LABEL,renteIsPopup);
  XtPopup(renteShell, XtGrabNone);
}

void RenteFortryd(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  renteIsPopup=0;
  updateMarkWithText(INTEREST_LABEL,renteIsPopup);
  XtPopdown(renteShell);
  XtVaSetValues(renteResult,
		XtNlabel, " ",
		NULL);
}

static long dato1, dato2;
static double fod1, fod2, bel;

void RenteBeregn(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  char buf[32], text[256];
  String p;

  XtVaGetValues(renteDato1In, 
		XtNstring, &p,
		NULL); 

  zeroAddStrncpy(buf,p,31);
  dato1=atoi(buf);

  if(dato1<=0) {
    xfError(ERR_DO_SUPPLY_DATE, NONFATAL, "interest");
    return;
  }

  XtVaGetValues(renteDato2In, 
		XtNstring, &p,
		NULL); 

  zeroAddStrncpy(buf,p,31);
  dato2=atoi(buf);

  if(dato2<=0) {
    xfError(ERR_DO_SUPPLY_DATE, NONFATAL, "interest");
    return;
  }
  if(dato2<=dato1) {
    xfError(ERR_WRONG_SEQUENCE, NONFATAL, "interest");
    return;
  }


  XtVaGetValues(renteFod1In, 
		XtNstring, &p,
		NULL); 

  zeroAddStrncpy(buf,p,31);
  fod1=atof(nocomma(buf));

  XtVaGetValues(renteFod2In, 
		XtNstring, &p,
		NULL); 

  zeroAddStrncpy(buf,p,31);
  fod2=atof(nocomma(buf));
  bel=okRente(dato1, dato2, fod1, fod2);
  sprintf(text, "%d %s (%d-%d, %4.2f, %4.2f)    %9.2f", dato2, INTEREST_LABEL,
		dato1, dato2, fod1, fod2, bel);

  XtVaSetValues(renteResult,
		XtNlabel, text,
		NULL);

  XtSetSensitive(renteTilskriv, TRUE); 
}

void RenteTilskriv(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  char text[128], dat[16], belText[32];
  sprintf(text, "%s (%d-%d, %4.2f, %4.2f)", INTEREST_LABEL, dato1, dato2, 
	  fod1, fod2);
  sprintf(dat, "%d", dato2);
  sprintf(belText, "%.2f", bel);

  okNyPost(0,dat, text, belText);
  saveKonto();
  opdaterPostList();

  renteIsPopup=0;
  updateMarkWithText(INTEREST_LABEL,renteIsPopup);
  XtPopdown(renteShell);
  XtVaSetValues(renteResult,
		XtNlabel, " ",
		NULL);
}

void CommitCallback(w, client_data, call_data)
Widget w;
XtPointer client_data, call_data;
{
  int i;
  i=indxOfPostSelection();
  if( i<0 ) {
    xfError(ERR_DO_CLICK_POSTING, NONFATAL, "commit");
    return;
  }
  
  doCommit(i);
}
