/* $Id: window.h,v 2.1 1995/03/30 16:13:17 lupus Exp lupus $ */

#ifndef WINDOW_H
#define WINDOW_H

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>

#include <X11/Xaw/Command.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/Scrollbar.h>
#include <X11/Xaw/Text.h>
#include <X11/Xaw/AsciiText.h> 

#include <X11/Xaw/MenuButton.h> 
#include <X11/Xaw/SimpleMenu.h> 
#include <X11/Xaw/SmeBSB.h> 
#include <X11/Xaw/SmeLine.h> 

#define NYPOST 1
#define RETPOST 2

#define S_WIDTH 445
#define S_HEIGHT 330

#define KONTO_BUTW 52
#define POST_BUTW KONTO_BUTW

#define COMMIT_SUPPORT 0
#define WINDEBUG 0

typedef struct {
  String text;
  int active;
  int opcode;
  Widget button;
} menu_item;

void mainWindow(int argc, char **argv);
int indxOfKontoSelection(void);
static void ValgKontoCallBack(Widget w, XtPointer client_data, 
			      XtPointer call_data);
void opdaterPostList(void);
static void KontoListSelectionCallBack(Widget w, XtPointer client_data, 
				       XtPointer call_data);
int indxOfPostSelection(void);
void SletPostCancel(Widget w, XtPointer client_data, XtPointer call_data);
void SletPostConfirm(Widget w, XtPointer client_data, XtPointer call_data);
void SletPostPopup(Widget w, XtPointer client_data, XtPointer call_data);

void PosteringPopup(Widget w, XtPointer client_data, XtPointer call_data);
void PostConfirm(Widget w, XtPointer client_data, XtPointer call_data);
void PostCancel(Widget w, XtPointer client_data, XtPointer call_data);
void PostClear(Widget w, XtPointer client_data, XtPointer call_data);

void NyPostConfirm(Widget w, XtPointer client_data, XtPointer call_data);
void NyPostCancel(Widget w, XtPointer client_data, XtPointer call_data);
void DagsDato(Widget w, XtPointer client_data, XtPointer call_data);
void PlusDato(Widget w, XtPointer client_data, XtPointer call_data);
void MinusDato(Widget w, XtPointer client_data, XtPointer call_data);
void PlusMon(Widget w, XtPointer client_data, XtPointer call_data);
void MinusMon(Widget w, XtPointer client_data, XtPointer call_data);

void RetPostConfirm(Widget w, XtPointer client_data, XtPointer call_data);
void RetPostCancel(Widget w, XtPointer client_data, XtPointer call_data);

void NyPostCallBack(Widget w, XtPointer client_data, XtPointer call_data);
void RetPostCallBack(Widget w, XtPointer client_data, XtPointer call_data);

void OvfPopup(Widget w, XtPointer client_data, XtPointer call_data);
void OvfConfirm(Widget w, XtPointer client_data, XtPointer call_data);
void OvfCancel(Widget w, XtPointer client_data, XtPointer call_data);
void OvfClearAll(Widget w, XtPointer client_data, XtPointer call_data);
void OvfClearText(Widget w, XtPointer client_data, XtPointer call_data);

void UdsOk(Widget w, XtPointer client_data, XtPointer call_data);
void UdsCancel(Widget w, XtPointer client_data, XtPointer call_data);
void UdsPopup(Widget w, XtPointer client_data, XtPointer call_data);

void PrinterConfigOk(Widget w, XtPointer client_data, XtPointer call_data);
void PrinterConfigCancel(Widget w, XtPointer client_data, XtPointer call_data);
void PrinterConfigPopup(Widget w, XtPointer client_data, XtPointer call_data);
void PrinterConfigPS(Widget w, XtPointer client_data, XtPointer call_data);

void Rente(Widget w, XtPointer client_data, XtPointer call_data);
void RenteFortryd(Widget w, XtPointer client_data, XtPointer call_data);
void RenteBeregn(Widget w, XtPointer client_data, XtPointer call_data);
void RenteTilskriv(Widget w, XtPointer client_data, XtPointer call_data);
void CommitCallback(Widget w, XtPointer client_data, XtPointer call_data);

void updateMark(Widget w, int set);
void updateMarkNumber(int number, int set);
void updateMarkWithText(char *text, int set);

#endif
